/*
 * JSONP requires the server to recognize the "&callback=FUNCTION_NAME..." parameter in the request, and return
 * the requested file as a parameter to FUNCTION_NAME.
 * 
 * JQuery allows the callback function to be anonymous (or any function) by internally
 * replacing a '?' with a generated name
 * $.getJSON('http://example.com/page?q='+q+'&callback=?', function(data){
		your_function(data);
	});
	
 *
 *	Novil's server doesn't support JSONP. So the workaround is to have the requested file (DbDataConf.json)
 *  start with a hardcoded call to our function 'UD.updateDone(....);'
 *  This way there will be a timeout in the call to the on-the-fly generated function, but will still
 *  call our hardcoded function (UD.updateDone).
 *  
 *  To create a DbDataConfs.json file, use existing convert.js: 'node convert.js > DbDataConf.json'
 *  It will add a valid js file, Json.stringify it, and add the call to UD.updateDone() at start.
 *  No need for convert.js anymore: Django created it in exports.py
 *  
 *  Set MimeType on server:
 *  application/javascript	json
 *  
 */

NVL.UD.updateData= function(){
	var url= NVL.customize.update.url;
	url = url+'?callback=?';
	console.log("Calling " + url + " to update");
	/* This worked for JQuery 1.6
	  $. getJSON( url, function(data){
		// this is never called, as Novil's server doesn't support JSONP.
		console.log("Back from " + url + " update with JSONP");
		NVL.UD.updateDone(data);
		console.log("Back from " + url + " update with JSONP: Done");
	});*/
	// THis is for JQuery 1.9
	$.ajax({
//		  dataType: "json",
		  dataType: "script",
		  url: url,
		  data: {},
		  //success:NVL.UD.updateDone,
	      error: function (error) {
	        if (error.status === 204) {
		        console.log("ERROR 204 = SUCCESS" +  error ); // server response
	        	//eval(error.responseText);
	        } else if (error.status === 200) {
		        console.log("ERROR 200 = SUCCESS" +  error ); // server response
	        	//eval(error.responseText);
	        } else {
		        console.log("ERROR " +  error ); // server response
	        };
	      },
		});
};



NVL.UD.updateDone= function(data){
	console.log("Back from update with hacked JSONP");
	console.log(data);
	eval(data);
	NVL.db.checkVersion();
	console.log("Back from update with hacked JSONP: DONE");
};


NVL.UD.clickRefreshDataMenu= function clickFavorites(){
	NVL.dbf.backList.add(NVL.UD.clickRefreshDataMenu);
	NVL.UD.getRefreshDataMenu(NVL.UD.printRefreshDataMenu);
};
NVL.UD.printRefreshDataMenu= function(tx, sqlResult){
	NVL.display.setToolbarTitle("Actualizar data");
	if (0 == sqlResult.rows.length){
		document.getElementById("content").innerHTML= "";
		NVL.display.showContent();		
		return;
	}
	var res={};
	for (var i=0; i< sqlResult.rows.length; i++){
		var entry= sqlResult.rows.item(i);
		res[entry.key]=entry.val;
		//console.log(res);
	}

	var lastDate= sqlResult.rows.item(0).date;
	var htmlText='';
	htmlText+='<div class="ui-grid-a">';
	htmlText+='  <div class="ui-block-a">';
	htmlText+='    Version (fecha):';
	htmlText+='  </div>';
	htmlText+='  <div class="ui-block-b">';
	htmlText+='		'+res.dbVersion+'  ('+res.dbVersion_date+')';
	htmlText+='  </div>';
	htmlText+='  <div class="ui-block-a">';
	htmlText+='    Ultima actualizacion: ';
	htmlText+='  </div>';
	htmlText+='  <div class="ui-block-b">';
	htmlText+='		'+res.db_version_last_check;
	htmlText+='  </div>';
	htmlText+='</div>';
	htmlText+='<button id="RefreshDataButton" onclick="NVL.UD.refreshButtonClick()">';
	htmlText+='  Actualizar ahora (requiere internet/WiFi)';
	htmlText+='</button>';
	document.getElementById("content").innerHTML= htmlText;
	NVL.display.showContent();
};

NVL.UD.refreshButtonClick= function refreshButtonClick(){
	$('#RefreshDataButton').text("Actualizando.... ");
	$('#RefreshDataButton').attr('disabled','disabled');
	NVL.UD.updateData();
};


NVL.UD.getRefreshDataMenu= function(succCB){
	var sql=  "SELECT * FROM tblConfig " ;
	console.log(sql);
	NVL.db.conn.transaction( function(tx) {
			tx.executeSql(sql,[], succCB, NVL.db.errorCB);
	});
};
